//+------------------------------------------------------------------+
//|                                               Marti_Orel_v02.mq4 |
//|                                          Copyright  2007, Silem |
//|                                                     silem@k66.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Silem"
#property link      "silem@k66.ru"
#include <stdlib.mqh>

/*  

*/


//---- input parameters
extern int       MN=100;
extern string    t0="Main Params";
extern int       TP=20;
extern bool      UseEqSL=true;
extern int       SL=40;
extern int       Step=20;
extern bool      StopTrade=false;
extern string    t1="Trailing Stop";
extern bool      UseTS=true;
extern int       TS=15;
extern int       TStep=2;
extern string    t2="Lot Management";
extern double    Lot=0.01;
extern int       UseMM=1;
extern int       IniBal=1000;
extern string    t3="Marty Params";
extern double    Multiplier=2;
extern int       NumberOfSteps=20;
extern bool      UseOrderClose=true;
extern int       StepOrderClose=4;
extern int       NeedProfit=2;
extern string    t4="Type of Entry";
extern int       EntryMode=2; // 1 - MA slope, 2 - price against MA
extern int       MA_TF=0;
extern int       MA_Per=100;
extern int       MA_Method=3; // MODE_SMA 0, MODE_EMA 1, MODE_SMMA 2, MODE_LWMA 3 
extern int       MA_ApplPrice=4; //PRICE_CLOSE 0, PRICE_OPEN 1, PRICE_HIGH 2, PRICE_LOW 3, PRICE_MEDIAN 4, (high+low)/2, PRICE_TYPICAL 5, (high+low+close)/3, PRICE_WEIGHTED 6 (high+low+close+close)/4 
extern string    t5="Time Management";
extern int       StartHour=0;
extern int       EndHour=24;
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
 {
//----
  int T=0, n=0, s=0;
  bool enterBuy=false;
  bool enterSell=false;
  double _spr=Ask-Bid;
  int ticket, err;
  bool tic;
 // block for entry point
  
  if (EntryMode==1)
   {
    double MA1=iMA(Symbol(),MA_TF,MA_Per,0,MA_Method,MA_ApplPrice,1);
    double MA2=iMA(Symbol(),MA_TF,MA_Per,0,MA_Method,MA_ApplPrice,2);
    if (MA1>MA2)
     {
      enterBuy=true;
     } else
     {
      enterSell=true;
     }
   }
  if (EntryMode==2)
   {
    MA1=iMA(Symbol(),MA_TF,MA_Per,0,MA_Method,MA_ApplPrice,1);
    if (Close[1]>MA1)
     {
      enterBuy=true;
     } else
     {
      enterSell=true;
     }
   }

 // end of block

    double prof=0;
    for(int i=OrdersTotal()-1;i>=0;i--)
     { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN)
       {
        prof=prof+OrderProfit()+OrderSwap();
       }
     } 
  if (UseEqSL) {SL=TP+Step;}
  if (UseMM==1) 
   {
    double InitLots=MathCeil(AccountBalance()/IniBal)/100;
   } else
   {
    InitLots=Lot;
   }
  if (InitLots<0.01) InitLots=0.01;
  for(i=0;i<OrdersTotal();i++)
   { 
    OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
    if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN) 
     {
      T++;
      if(OrderType()==OP_BUY) 
       {
        s=1;
        double LastBuy=OrderOpenPrice();
        double LastBuyLot=OrderLots();
       }
      if(OrderType()==OP_SELL)
       {
        s=2;
        double LastSell=OrderOpenPrice();
        double LastSellLot=OrderLots();
       }
      if(OrderType()!=OP_SELL && OrderType()!=OP_BUY)
       {
        n=1;
       }
     } //     -  , s=1 -  , s=2 -      
   }
  if (T>2) //     
   {
    for(i=OrdersTotal()-1;i>=0;i--)
     { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN && OrderType()==OP_BUY && OrderTakeProfit()==0)
       {
        tic=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderOpenPrice()+TP*Point,0,CLR_NONE);
        if (!tic) 
         {
          err=GetLastError();
          Print(" (",err,")  : ",ErrorDescription(err));
         }
       }
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN && OrderType()==OP_SELL && OrderTakeProfit()==0)
       {
        tic=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),OrderOpenPrice()-TP*Point,0,CLR_NONE);
        if (!tic) 
         {
          err=GetLastError();
          Print(" (",err,")  : ",ErrorDescription(err));
         }
       }
     }
   }
  if (T==2 && s!=0 && UseTS) //    
   {
    for (i=0; i<OrdersTotal(); i++) 
     {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
       {
        if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN && OrderTakeProfit()==0) 
         {
          if (OrderType()==OP_BUY) 
           {
            RefreshRates();
            if (Bid-OrderOpenPrice()>TS*Point) 
             {
              if (OrderStopLoss()<Bid-(TS+TStep-1)*Point) 
               {
                ModifyStopLoss(Bid-TS*Point, Green);
               }
             }
           }
          if (OrderType()==OP_SELL) 
           {
            if (OrderOpenPrice()-Ask>TS*Point) 
             {
              if (OrderStopLoss()>Ask+(TS+TStep-1)*Point) 
               {
                ModifyStopLoss(Ask+TS*Point, Green);
               }
             }
           }
         }
       }
     }
   }

  if (s==0 && n==1) //      
   {
    for(i=OrdersTotal()-1;i>=0;i--)
     { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN && OrderType()!=OP_BUY && OrderType()!=OP_SELL)
       {
        tic=OrderDelete(OrderTicket());
        if (!tic) 
         {
          err=GetLastError();
          Print(" (",err,")  : ",ErrorDescription(err));
         }
       }
     } 
   }
  if (T==0 && n==0 && !StopTrade && Hour()>=StartHour && Hour()<EndHour) //   
   {
    RefreshRates();
    if (enterBuy)
     {
      if (UseTS)
       {
        ticket=OrderSend(Symbol(),OP_BUY,InitLots,Ask,3,Ask-SL*Point-_spr,0,"First Buy",MN,0,Blue);
        if (ticket<0) 
         {
          err=GetLastError();
          Print(" (",err,")   BUY: ",ErrorDescription(err));
         }
       }
      if (!UseTS)
       {
        ticket=OrderSend(Symbol(),OP_BUY,InitLots,Ask,3,Ask-SL*Point-_spr,Ask+TP*Point,"First Buy",MN,0,Blue);
        if (ticket<0) 
         {
          err=GetLastError();
          Print(" (",err,")   BUY: ",ErrorDescription(err));
         }
       }
     }
    if (enterSell)
     {
      if (UseTS)
       {
        ticket=OrderSend(Symbol(),OP_SELL,InitLots,Bid,3,Bid+SL*Point+_spr,0,"First Sell",MN,0,Red);
        if (ticket<0) 
         {
          err=GetLastError();
          Print(" (",err,")   SELL: ",ErrorDescription(err));
         }
       }
      if (!UseTS)
       {
        ticket=OrderSend(Symbol(),OP_SELL,InitLots,Bid,3,Bid+SL*Point+_spr,Bid-TP*Point,"First Sell",MN,0,Red);
        if (ticket<0) 
         {
          err=GetLastError();
          Print(" (",err,")   SELL: ",ErrorDescription(err));
         }
       }
     }
   }
  if (T>0 && n==0 && T<NumberOfSteps) //    
   {
    if (s==1)
     {
      double lts;
      if (InitLots==LastBuyLot)
       {
        lts=NormalizeDouble(LastBuyLot*Multiplier*1.5,2);
       } else
       {
        lts=NormalizeDouble(LastBuyLot*Multiplier,2);
       }        
      ticket=OrderSend(Symbol(),OP_SELLSTOP,lts,LastBuy-Step*Point,0,LastBuy-(Step-SL)*Point+_spr,LastBuy-(Step+TP)*Point,"Next Sell",MN,0,Red);
      if (ticket<0) 
       {
        err=GetLastError();
          Print(" (",err,")   SELLSTOP: ",ErrorDescription(err));
       }
     }
    if (s==2)
     {
      if (InitLots==LastSellLot)
       {
        lts=NormalizeDouble(LastSellLot*Multiplier*1.5,2);
       } else
       {
        lts=NormalizeDouble(LastSellLot*Multiplier,2);
       }        
      ticket=OrderSend(Symbol(),OP_BUYSTOP,lts,LastSell+Step*Point,0,LastSell+(Step-SL)*Point-_spr,LastSell+(Step+TP)*Point,"Next Buy",MN,0,Blue);
      if (ticket<0) 
       {
        err=GetLastError();
          Print(" (",err,")   BUYSTOP: ",ErrorDescription(err));
       }
     }
   }
  if (UseOrderClose && T>=StepOrderClose+1) //       
   {
    prof=0;
    for(i=OrdersTotal()-1;i>=0;i--)
     { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN)
       {
        prof=prof+OrderProfit()+OrderSwap();
       }
     } 
    double _tv=MarketInfo(Symbol(),MODE_TICKVALUE);
    double need_prof=_tv*InitLots*NeedProfit;
//    Print("  ",prof,".   ",need_prof);
    if (prof>=need_prof)
     {
/*      while(OrdersTotal()>1)
       { 
        int mnb=0,mns=0;
        for(i=OrdersTotal()-1;i>=0;i--)
         { 
          OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
          if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN)
           {
            if (OrderType()==OP_BUY)
             {
              mnb=OrderTicket();
//              Print("mnb ",mnb); 
             }
           }
         }
        for(i=OrdersTotal()-1;i>=0;i--)
         { 
          OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
          if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN)
           {
            if (OrderType()==OP_SELL)
             {
              mns=OrderTicket();
//              Print("mns ",mns); 
             }
           }
         }
        if (mnb!=0 && mns!=0)
         {
          RefreshRates();
//          Print("  "); 
          tic=OrderCloseBy(mnb,mns,Gold);
          if (ticket<0) 
           {
            err=GetLastError();
            Print(" (",err,")   : ",ErrorDescription(err));
           }
         }
        if (mnb==0 || mns==0)
         {
//          Print("   "); */
          for(i=OrdersTotal()-1;i>=0;i--)
           { 
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
            if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN && OrderType()==OP_BUY)
             {
              RefreshRates();
              OrderClose(OrderTicket(),OrderLots(),Bid,3,Green);
              if (ticket<0) 
               {
                err=GetLastError();
                Print(" (",err,")   BUY: ",ErrorDescription(err));
               }
             }
            if (OrderSymbol()==Symbol() && OrderMagicNumber()==MN && OrderType()==OP_SELL)
             {
              RefreshRates();
              OrderClose(OrderTicket(),OrderLots(),Ask,3,Green);
              if (ticket<0) 
               {
                err=GetLastError();
                Print(" (",err,")   BUY: ",ErrorDescription(err));
               }
             }
//       }
//     }
       } 
     }
   }
  Comment("   ", T-1,"\n",
          "    ",prof);

//----
  return(0);
 }
//+------------------------------------------------------------------+

void ModifyStopLoss(double ldStop, color clModify) 
 {
  bool   fm;
  double ldOpen=OrderOpenPrice();
  double ldTake=OrderTakeProfit();
  int    err;
  if (IsTradeAllowed()) 
   {
    fm=OrderModify(OrderTicket(), ldOpen, ldStop, ldTake, 0, clModify);
    if (!fm) 
     {
      err=GetLastError();
      Print(" (",err,") : ",ErrorDescription(err));
     }
   }
 }

